
{*******************************************************}
{                                                       }
{       JADScript compiler by Y [27-11-00]              }
{       JADScript code generator (JDS decompiler ;)     }
{                                                       }
{       Copyright (c) 1999-2000 YALLIE, Inc.            }
{       All Rights Reserved.                            }
{                                                       }
{*******************************************************}

unit CCodeJads; {$DEFINE DEBUG}

interface

uses Objects, CConstants, CCodeGenerator, CLists;

const
  cTab = '  ';

type
  PJadCodeGenerator = ^TJadCodeGenerator;
  TJadCodeGenerator = object(TCodeGenerator)
    constructor Init(aFileName: String);
    procedure Generate(JadObject: PJadObject);

    procedure EmitObject(JadObject: PJadObject; Level: Integer);
  end;

implementation

constructor TJadCodeGenerator.Init(aFileName: String);
begin
  inherited Init(aFileName, stC);
end; {TJadCodeGenerator.Init}

procedure TJadCodeGenerator.Generate(JadObject: PJadObject);
begin
  EmitLn;

  if JadObject <> nil then
    EmitObject(JadObject, 0)
  else
    EmitComment('Data object is not assigned.');

  EmitLn;
end; {TJadCodeGenerator.Generate}

procedure TJadCodeGenerator.EmitObject(JadObject: PJadObject; Level: Integer);
var
  Margin: String;
  i: Integer;
begin
  Margin := '';
  for i := 1 to Level do
    Margin := Margin + cTab;

  {type}
  if JadObject^.GetType <> '' then
  begin
    Emit(Margin);
    Emit('type = ');
    EmitStringConstant(JadObject^.GetType, '""');
    EmitLn
  end;

  {attributes}
  if JadObject^.GetAttributesCount <> 0 then
  begin
    Emit(Margin);
    EmitLine('attributes = (');
    for i := 1 to JadObject^.GetAttributesCount do
    begin
      Emit(Margin + cTab);
      Emit(JadObject^.NameAt(i - 1));
      Emit(' = ');
      EmitStringConstant(JadObject^.ValueAt(i - 1), '""');
      EmitLn;
    end;
    EmitLine(Margin + ')');
  end;

  {objects}
  for i := 1 to JadObject^.GetObjectsCount do
  begin
    EmitLn;
    EmitLine(Margin + 'object = (');

    EmitObject(JadObject^.ObjectAt(i - 1), Level + 1);

    EmitLine(Margin + ')');
  end;
end; {EmitObject}

end {CCodeJads}.
