
{*******************************************************}
{                                                       }
{       JADScript compiler by Y [27-11-00]              }
{       Common constants and types                      }
{                                                       }
{       Copyright (c) 1999-2000 YALLIE, Inc.            }
{       All Rights Reserved.                            }
{                                                       }
{*******************************************************}

unit CConstants;

{$I CDEFINES.PAS} {$IFDEF TPC} {$N+} {$ENDIF}

interface

uses Objects;

const
  Version = '0.00 alpha';

type

  {Miscellaneous}

  SmallString = String[4]; {short string type}
  CharSet = set of char;
  Float = Extended;
  PFloat = ^Float;
  TEncoding = (en866, en1251, enKoi8); 

  {Language specific}

  TReservedWord = (rwUnknown, rwAttributes, rwObject, rwType);

  {Compiler error codes}

  TCompilerError = (ceNoErrors, ceUnknownError, ceCommentNotClosed,
    ceStringNotClosed, ceEndOfFileExpected, ceIdentifierExpected,
    ceConstantOutOfRange, ceEqualExpected, ceStringConstantExpected,
    ceLeftParenthesisExpected, ceRightParenthesisExpected,
    ceFileNotFound,

    ceInternalError);

  { Date-time string formats }

  TDateTimeFormat = (dtDay, dtMonth, dtYear, dtDate, dtUsDate, dtShortDate,
    dtShortUsDate, dtWhyDate, dtWhyUsDate, dtTime, dtDateTime);

const

  {Stream objects error codes}

  stNoMorePlace = -20;
  stCompilerError = -21;

  {Miscellaneous constants}

  MaxTableSize = 1024; {values/strings/etc per one symbol table}
  ReadBufferSize = 4096; {low level file I/O buffer size}
  SecondBufferSize = 32; {must be 255 or less}
  CaseSensitive = False;
  MinFloat = 3.4e-4932;
  MaxFloat = 1.1e+4932;
  LoCaseDelta = Byte('a') - Byte('A'); {for LoCase and LowerCase}
  UpCaseDelta = -LoCaseDelta;

  {Language-specific constants}

  ReservedWords: array [1..Ord(High(TReservedWord))] of PChar =
    ('attributes', 'object', 'type');

  Delimiters: array [1..30] of char = '!"#$%&''()*+,-./:;<=>?@[\]^{|}~';
  Letters: set of char = ['A'..'Z', 'a'..'z', '_'];
  HexDigits: set of char = ['0'..'9', 'A'..'F', 'a'..'f'];
  Digits: set of char = ['0'..'9'];
  OctDigits: set of char = ['0'..'7'];
  BinDigits: set of char = ['0', '1'];

  SkipChars: set of char = [#0..' ', '~'..#$FF];
  CR = #13;
  LF = #10;

  cCHexPrefix: String[2] = '0x';
  cPasHexPrefix = '$';
  sHexChars: String[16] = '0123456789ABCDEF';

  sAdaDoubleLineComment = '--';
  sAltDoubleLineComment = '<-';
  sAsmEscape = '\';
  sAsmEscapeSequences: String = '\\;;'; { xor ax, ax \; zero register }
  sAssignment = ':=';
  sDoubleComment = '/**/';
  sDoubleLineComment = '//';
  sDoubleDot = '..';
  sGreaterEqual = '>=';
  sLeftBracket = '(.';
  sRightBracket = '.)';
  sLessEqual = '<=';
  sNotEqual = '<>';
  sSingleComment = '()';
  sSingleLineComment = '\';
  sStringChars = '""';
  sCharacterChars = ''''''; {nice, eh? ;}
  sStringEscape = '\'; {"Hello\n"}
  sStringEscapeSequences: String = '\\""''''n'#10'r'#13't'#9'b'#8; {"\" \\"}
  sTranslateFrom866 = '񦧨';
  sTranslateFrom1251 = 'Ũ';
  sTranslateFromKoi8 = 'ţ';
  sTranslateTo: String = 'ABVGDEEJZIJKLMNOPRSTUFHCCSXYYYEWQabvgdeejzijklmnoprstufhccsxyyyewq';
  sIptCadType: String = 'IptCad Project File';

  {Compiler error messages}

  ErrorMessages: array [TCompilerError] of PChar = ('ok', 'unknown error',
    'comment not closed', 'string not closed', 'end of file expected',
    'identifier expected', 'constant out of range', '"=" expected',
    'string constant expected', '"(" expected', '")" expected',
    'file not found',

    'internal error');

  rwLast = rwType;

  ShortMonths: array [1..12] of PChar = ('Jan', 'Feb', 'Mar', 'Apr', 'May',
    'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
  Months: array [1..12] of PChar = ('January', 'February', 'March', 'April',
    'May', 'June', 'July', 'August', 'Septemnber', 'October', 'November',
    'December');
  ShortDayOfWeeks: array[1..7] of PChar = ('Sun', 'Mon', 'Tue', 'Wed',
    'Thi', 'Fri', 'Sat');
  DayOfWeeks: array[1..7] of PChar = ('Sunday', 'Monday', 'Tuesday',
    'Wednesday', 'Thirsday', 'Friday', 'Saturday');

  HmmMessages: array[0..22] of PChar = ('hmm...', 'opps!', 'sorry ;)',
    'pardon', 'hey-hey!', 'yah-o-o!', 'pooh!', 'whack...', 'blah!',
    'what the hell?!', 'so sorry', 'beg for excuse', 'faugh!', 'foo :*)',
    ';)', ':(', 'do you like it?', 'come on baby', 'damn...', 'nice, eh?',
    '(c) Microsoft', 'must die', 'spaghetti rules');

  { PRO file format constants, as described by S. Serdukov }

  { element types }
  elBlock = $01;
  elProcess = $05;
  elCondition = $04;
  elEntryExit = $0A;
  elEntry = $02;
  elExit = $09;
  elConstants = $0B;
  elVariables = $0C;
  elComment = $07;
  elConnector = $03;

  { signatures }
  cStartPageArray = 'B';
  cEndPageArray = 'E';
  cStartPage = 'b';
  cEndPage = 'e';

  { miscellaneous }
  cPageNameLength = 50;

type

  TTokenKind = (tkUnknown, tkBigDelimiter, tkDelimiter, tkFloat,
    tkIdentifier, tkInteger, tkReservedWord, tkString);

  {TToken}

  TToken = record
    Line, Position: Integer;
    StringChars: SmallString;
    case Kind: TTokenKind of
      tkIdentifier, tkString, tkBigDelimiter:
        (S: String);
      tkDelimiter, tkInteger:
        (I: Longint); {index or integer value}
      tkReservedWord:
        (N: TReservedWord);
      tkFloat:
        (F: Float);
  end;

function IntToStr(Value: LongInt): String;
function StrToInt(Value: String): LongInt;
function IntToHex(Value: LongInt): String;
function LoCase(C: Char): Char;
function LowerCase(S: String): String;
function UpCase(C: Char): Char;
function UpperCase(S: String): String;
function CharToHex(Value: Char): String;
function HexToChar(Value: String): Char;
function CharToAlpha(Value: Char; Encoding: TEncoding): Char;
function DateTimeString(StringFormat: TDateTimeFormat): String;
procedure FloatVal(S: String; var Value: Float; var Error: Integer);
procedure FreeToken(var Token: TToken);
procedure StringToToken(var Token: TToken; S: String);
function GetHmmMessage: String;

implementation

uses DOS, Strings;

function IntToStr(Value: LongInt): String;
var
  Temp: String;
begin
  Str(Value, Temp);
  IntToStr := Temp;
end; {IntToStr}

function StrToInt(Value: String): LongInt;
var
  Temp: LongInt;
  Err: Integer;
begin
  Val(Value, Temp, Err);
  StrToInt := Temp;
end; {StrToInt}

function IntToHex(Value: LongInt): String;
var
  Temp: String;
begin
  Temp := '';

  if Value = 0 then
    Temp := '0'
  else
  begin
    Temp := sHexChars[Value and $F + 1];
    Value := Value shr 4;
    if Value <> 0 then
      Temp := IntToHex(Value) + Temp;
  end;

  IntToHex := Temp;
end; {IntToHex}

function LoCase(C: Char): Char;
begin
  if (C >= 'A') and (C <= 'Z') then
    C := Char(Byte(C) + LoCaseDelta);
  LoCase := C;
end; {LoCase}

function LowerCase(S: String): String;
var
  i: Integer;
  C: Char;
begin
  for i := 1 to Length(S) do
  begin
    C := S[i];
    {if C in ['A'..'Z'] then}
    if (C >= 'A') and (C <= 'Z') then
      S[i] := Char(Byte(C) + LoCaseDelta);
  end;
  LowerCase := S;
end; {LowerCase}

function UpCase(C: Char): Char;
begin
  if (C >= 'a') and (C <= 'z') then
    C := Char(Byte(C) + UpCaseDelta);
  UpCase := C;
end; {UpCase}

function UpperCase(S: String): String;
var
  i: Integer;
  C: Char;
begin
  for i := 1 to Length(S) do
  begin
    C := S[i];
    {if C in ['A'..'Z'] then}
    if (C >= 'a') and (C <= 'z') then
      S[i] := Char(Byte(C) + UpCaseDelta);
  end;
  UpperCase := S;
end; {UpperCase}

function CharToHex(Value: Char): String;
var
  Temp: String;
begin
  Temp := sHexChars[Byte(Value) shr 4 + 1] +
    sHexChars[Byte(Value) and $F + 1];
  CharToHex := Temp;
end; {CharToHex}

function HexToChar(Value: String): Char;
var
  Temp: Char;
  i: Integer;
begin
  if Length(Value) >= 2 then
  begin
    for i := 1 to 2 do
    begin
      Value[i] := UpCase(Value[i]);
      if Value[i] >= 'A' then
        Value[i] := Char(Byte(Value[i]) + 10 - Byte('A'))
      else
        Value[i] := Char(Byte(Value[i]) - Byte('0'));
    end;
    Temp := Char(Byte(Value[1]) shl 4 + Byte(Value[2]));
  end
  else
    Temp := #0;

  HexToChar := Temp;
end; {HexToChar}

function CharToAlpha(Value: Char; Encoding: TEncoding): Char;
var
  i: Integer;
  sTranslateFrom: String;
begin
  case Encoding of
    en866: sTranslateFrom := sTranslateFrom866;
    en1251: sTranslateFrom := sTranslateFrom1251;
    else sTranslateFrom := sTranslateFromKoi8;
  end;

  if not (Value in ['A'..'Z', 'a'..'z']) then
  begin
    i := Pos(Value, sTranslateFrom);
    if i <> 0 then
      Value := sTranslateTo[i]
    else
      Value := '_';
  end;

  CharToAlpha := Value;
end; {CharToAlpha}

function DateTimeNumber(NumberFormat: TDateTimeFormat): LongInt;
var
  nDay, nMonth, nYear, nDayOfWeek, nHour, nMinute, nSecond, nSec100: Word;
begin
  GetDate(nYear, nMonth, nDay, nDayOfWeek);
  GetTime(nHour, nMinute, nSecond, nSec100);
  DateTimeNumber := 0;
end; {DateTimeNumber}

function DateTimeString(StringFormat: TDateTimeFormat): String;
var
  nDay, nMonth, nYear, nDayOfWeek, nHour, nMinute, nSecond, nSec100: Word;
  sDay, sMonth, sYear, sDayOfWeek, sHour, sMinute, sSecond, Temp: String;

  procedure ReplaceSpacesWithZeros(var S: String);
  var
    i: Integer;
  begin
    for i := 1 to Length(S) do
      if S[i] = ' ' then
        S[i] := '0';
  end; {ReplaceSpacesWithZeros}

begin
  GetDate(nYear, nMonth, nDay, nDayOfWeek);
  GetTime(nHour, nMinute, nSecond, nSec100);

  {convert to strings}
  Str(nDay: 2, sDay); ReplaceSpacesWithZeros(sDay);
  Str(nMonth: 2, sMonth); ReplaceSpacesWithZeros(sMonth);
  Str(nYear: 4, sYear); ReplaceSpacesWithZeros(sYear);
  Str(nHour: 2, sHour); ReplaceSpacesWithZeros(sHour);
  Str(nMinute: 2, sMinute); ReplaceSpacesWithZeros(sMinute);
  Str(nSecond: 2, sSecond); ReplaceSpacesWithZeros(sSecond);

  {form the string needed}
  case StringFormat of
    dtDay: Temp := sDay;
    dtMonth: Temp := StrPas(Months[nMonth]);
    dtYear: Temp := sYear;

    dtDate: Temp := sDay + ' ' + StrPas(ShortMonths[nMonth]) + ' ' + sYear;
    dtUsDate: Temp := StrPas(ShortMonths[nMonth]) + ' ' + sDay + ' ' + sYear;
    dtShortDate: Temp := sDay + '/' + sMonth + '/' + Copy(sYear, 3, 2);
    dtShortUsDate: Temp := sMonth + '/' + sDay + '/' + Copy(sYear, 3, 2);
    dtWhyDate: Temp := sDay + '-' + sMonth + '-' + Copy(sYear, 3, 2);
    dtWhyUsDate: Temp := sMonth + '-' + sDay + '-' + Copy(sYear, 3, 2);

    dtTime: Temp := sHour + ':' + sMinute + ':' + sSecond;
    dtDateTime: Temp := sYear + '/' + sMonth + '/' + sDay + ' ' +
      sHour + ':' + sMinute + ':' + sSecond + ' GMT';
    else Temp := ''
  end;

  {return the result}
  DateTimeString := Temp;
end; {DateTimeString}

{Warning! FloatVal accepts only high quality syntax-correct floating
point numbers with no leading spaces. The only possible error is a
floating point overflow or underflow.
Standard Val procedure cannot be used because it doesn't handle run-
time errors #205 (floating point overflow) and #206 (underflow). Un-
expected error may occur while processing too big or too small floa-
ting point values like 1.2e+4932 or 3.5e-4932.
In Delphi, try..except construction may be used to hook this occasi-
on to report a compiler error.}
procedure FloatVal(S: String; var Value: Float; var Error: Integer);
var
  TempFloat: Float;
  TempInteger, Position: Integer;
  TempString: String;
begin
  TempFloat := 0;

  {cut charasteristic and mantissa}
  Position := Pos('e', LowerCase(S));
  if (Position = 0) then
    TempString := S
  else
    TempString := Copy(S, 1, Position - 1);

  {evaluate it; no errors possible here}
  Val(TempString, TempFloat, Error);

  {cut order}
  if (Position <> 0) then
    TempString := Copy(S, Position + 1, Length(S) - Position)
  else
    TempString := '';

  if (TempString <> '') then
  begin
    if not (TempString[1] in ['+', '-']) then
      TempString := '+' +TempString;

    if (Length(TempString) < 6) then
    begin
      {evaluate order}
      Val(TempString, TempInteger, Error);

      {calculate the final value}
      if (TempInteger > (Ln(MaxFloat) / Ln(10))
        - (Ln(TempFloat) / Ln(10))) then
        Error := Position + Length(TempString)
      else
        if (TempInteger < (Ln(MinFloat) / Ln(10))
          + (Ln(TempFloat) / Ln(10))) then
          Error := Position + Length(TempString)
        else
          TempFloat := TempFloat * Exp(TempInteger * Ln(10));
    end
    else
      Error := Position + 6;
  end;

  if (Error = 0) then
    Value := TempFloat;
end; {FloatVal}

procedure EraseToken(var Token: TToken);
begin
  with Token do
  begin
    {Line := 0; Position := 0;} {8-D}
    Kind := tkUnknown;
    I := 0;
    F := 0;
    S := '';
    StringChars := '';
  end;
end; {EraseTToken}

procedure FreeToken(var Token: TToken);
begin
  EraseToken(Token);
end; {FreeToken}

procedure StringToToken(var Token: TToken; S: String);
begin
  FreeToken(Token);
  Token.S := S;
end; {StringToToken}

function IsReservedWord(S: String): TreservedWord;
var
  i, Temp: TReservedWord;
begin
  Temp := rwUnknown;
  for i := rwUnknown to rwLast do
    if LowerCase(StrPas(ReservedWords[Ord(i)])) = LowerCase(S) then
      Temp := i;
  IsReservedWord := Temp;
end; {IsReservedWord}

function GetHmmMessage: String;
begin
  GetHmmMessage := StrPas(HmmMessages[Random(High(HmmMessages))]);
end; {GetHmmMessage}

begin
  Randomize;
end {CConstants}.
