
{*******************************************************}
{                                                       }
{       JADScript compiler by Y [27-11-00]              }
{       Project file                                    }
{                                                       }
{       Copyright (c) 1999-2000 YALLIE, Inc.            }
{       All Rights Reserved.                            }
{                                                       }
{*******************************************************}

program Jads;

{$I CDEFINES.PAS}
{$IFDEF TPC} {$N+,V-,M 32768,120000,120000} {$ENDIF}
{$I-}

uses Dos, Objects, CSyntax, CConstants, CCodeJads, CCodePascal;

var
  { JADScript compiler }
  Compiler: PJadsCompiler;
  { Code generators }
  JadCode: PJadCodeGenerator;
  PasCode: PPascalCodeGenerator;

var
  OldExitProc: Pointer;
  {options}
  opQuietMode: Boolean;

procedure About;
begin
  Writeln(
  'JADScript compiler. Version ' + Version + ' by Y [27-11-00]'#13#10 +
  'Copyright (c) 1999-2000 YALLIE, Inc. All Rights Reserved.'#13#10);
end; {About}

procedure Help;
var
  Dir, FileName, Ext: String;
begin
  FSplit(ParamStr(0), Dir, FileName, Ext);
  Writeln(
    'Syntax: ', FileName + Ext, ' [<switches>] <source.jds> [<switches>]'#13#10 +
    '/q = operate quetly'
  );
end; {Help}

{$F+}
procedure NewExitProc;
begin
  Dispose(PasCode, Done);
  Dispose(JadCode, Done);
  Dispose(Compiler, Done);

  ExitProc := OldExitProc;
end; {NewExitProc}
{$F-}

procedure Run(FileName: String);
var
  ModuleName, CdsFileName, PasFileName, Dir, Name, Ext: String;
begin
  {prepare source file name}
  if Pos('.', FileName) = 0 then
    FileName := FileName + '.JDS';

  {prepare destination file name}
  FSplit(FileName, Dir, Name, Ext);
  ModuleName := Name + Ext;
  CdsFileName := Dir + Name + '.CDS';
  PasFileName := Dir + Name + '.PP';

  {go}
  if not opQuietMode then
    Writeln('Compiling file: ', FileName, '...');

  New(Compiler, Init(FileName));
  New(JadCode, Init(CdsFileName));
  New(PasCode, Init(PasFileName));

  {assign new exit procedure}
  OldExitProc := ExitProc;
  ExitProc := @NewExitProc;

  {go ahead!}
  Compiler^.Compile;

  if not opQuietMode then
    Writeln(Compiler^.Lines,
      ' line(s) compiled successfully, no syntax errors detected.'#13#10);

  {generate code}
  if not opQuietMode then
    Writeln('Starting code generation...');
  JadCode^.Generate(Compiler^.JadObject);
  PasCode^.Generate(Compiler^.JadObject);

  if not opQuietMode then
    Writeln('All done.');
end; {Run}

function ExtractNextFileName(var FileNames: String): String;
var
  Temp: String;
  i, FileNamesLength: Integer;
begin
  Temp := '';

  {skip leading spaces}
  i := 1;
  FileNamesLength := Length(FileNames);
  while (i <= FileNamesLength) and (FileNames[i] = ' ') do
    Inc(i);
  if (i > 1) then
    Delete(FileNames, 1, i - 1);

  {extract file name}
  if (FileNames <> '') then
  begin
    i := Pos(' ', FileNames);
    if (i <> 0) then
      Temp := Copy(FileNames, 1, i - 1)
    else
    begin
      Temp := FileNames;
      i := Length(FileNames);
    end;
    Delete(FileNames, 1, i);
  end;

  ExtractNextFileName := Temp;
end; {ExtractNextFileName}

procedure ExtractSwitches(var ParamString: String);
var
  Temp: Integer;
begin
  opQuietMode := False;

  Temp := Pos('/q', ParamString);
  if (Temp = 0) then
    Temp := Pos('/Q', ParamString);

  if (Temp <> 0) then
  begin
    opQuietMode := True;
    Delete(ParamString, Temp, 2);
  end;

  Temp := Pos('/?', ParamString);
  if (Temp <> 0) then
    ParamString := '';
end; {ExtractSwitches}

var
  ParamString: String;
begin
  ParamString := String(Ptr(PrefixSeg, $80)^);
  ExtractSwitches(ParamString);

  if not opQuietMode then
    About;

  ParamString := ExtractNextFileName(ParamString);

  if (ParamString <> '') then
    Run(ParamString)
  else
  begin
    if opQuietMode then
      About;

    Help;

    Halt(256-1);
  end;
end {Jads}.
