
{*******************************************************}
{                                                       }
{       Pro2jds convertor by Y [28-11-00]               }
{       Project file                                    }
{                                                       }
{       Copyright (c) 1999-2000 YALLIE, Inc.            }
{       All Rights Reserved.                            }
{                                                       }
{*******************************************************}

program Pro2jds;

{$I CDEFINES.PAS}
{$IFDEF TPC} {$N+,V-,M 32768,120000,120000} {$ENDIF}
{$I-}

uses Dos, Objects, CConstants, CCodeJads, CProLoader;

var
  { Project Loader }
  ProLoader: PProLoader;
  { Code generator }
  JadCode: PJadCodeGenerator;

var
  OldExitProc: Pointer;
  {options}
  opQuietMode: Boolean;

procedure About;
begin
  Writeln(
  'Pro2jds convertor. Version ' + Version + ' by Y [28-11-00]'#13#10 +
  'Copyright (c) 1999-2000 YALLIE, Inc. All Rights Reserved.'#13#10);
end; {About}

procedure Help;
var
  Dir, FileName, Ext: String;
begin
  FSplit(ParamStr(0), Dir, FileName, Ext);
  Writeln(
    'Syntax: ', FileName + Ext, ' [<switches>] <source.pro> [<switches>]'#13#10 +
    '/q = operate quetly'
  );
end; {Help}

{$F+}
procedure NewExitProc;
begin
  Dispose(JadCode, Done);
  Dispose(ProLoader, Done);

  ExitProc := OldExitProc;
end; {NewExitProc}
{$F-}

procedure Run(FileName: String);
var
  ModuleName, JdsFileName, Dir, Name, Ext: String;
begin
  {prepare source file name}
  if Pos('.', FileName) = 0 then
    FileName := FileName + '.PRO';

  {prepare destination file name}
  FSplit(FileName, Dir, Name, Ext);
  ModuleName := Name + Ext;
  JdsFileName := Dir + Name + '.JDS';

  {go}
  if not opQuietMode then
    Writeln('Converting file: ', FileName, '...');

  New(ProLoader, Init(FileName));
  New(JadCode, Init(JdsFileName));

  {assign new exit procedure}
  OldExitProc := ExitProc;
  ExitProc := @NewExitProc;

  {go ahead!}
  ProLoader^.Load;

  if not opQuietMode then
    Writeln('Object tree created.'#13#10);

  {generate code}
  if not opQuietMode then
    Writeln('Starting code generation...');

  JadCode^.Generate(ProLoader^.JadObject);

  if not opQuietMode then
    Writeln('All done.');
end; {Run}

function ExtractNextFileName(var FileNames: String): String;
var
  Temp: String;
  i, FileNamesLength: Integer;
begin
  Temp := '';

  {skip leading spaces}
  i := 1;
  FileNamesLength := Length(FileNames);
  while (i <= FileNamesLength) and (FileNames[i] = ' ') do
    Inc(i);
  if (i > 1) then
    Delete(FileNames, 1, i - 1);

  {extract file name}
  if (FileNames <> '') then
  begin
    i := Pos(' ', FileNames);
    if (i <> 0) then
      Temp := Copy(FileNames, 1, i - 1)
    else
    begin
      Temp := FileNames;
      i := Length(FileNames);
    end;
    Delete(FileNames, 1, i);
  end;

  ExtractNextFileName := Temp;
end; {ExtractNextFileName}

procedure ExtractSwitches(var ParamString: String);
var
  Temp: Integer;
begin
  opQuietMode := False;

  Temp := Pos('/q', ParamString);
  if (Temp = 0) then
    Temp := Pos('/Q', ParamString);

  if (Temp <> 0) then
  begin
    opQuietMode := True;
    Delete(ParamString, Temp, 2);
  end;

  Temp := Pos('/?', ParamString);
  if (Temp <> 0) then
    ParamString := '';
end; {ExtractSwitches}

var
  ParamString: String;
begin
  ParamString := String(Ptr(PrefixSeg, $80)^);
  ExtractSwitches(ParamString);

  if not opQuietMode then
    About;

  ParamString := ExtractNextFileName(ParamString);

  if (ParamString <> '') then
    Run(ParamString)
  else
  begin
    if opQuietMode then
      About;

    Help;

    Halt(256-1);
  end;
end {Pro2jds}.
